Only in estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/build/lib/estimationtools: hoursplanned.py
diff -ru estimationtoolsplugin-13312/estimationtoolsplugin/trunk/build/lib/estimationtools/__init__.py estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/build/lib/estimationtools/__init__.py
--- estimationtoolsplugin-13312/estimationtoolsplugin/trunk/build/lib/estimationtools/__init__.py	2008-09-24 19:30:20.000000000 +0300
+++ estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/build/lib/estimationtools/__init__.py	2014-04-15 10:12:11.000000000 +0300
@@ -1,4 +1,6 @@
 import burndownchart

 import hoursinplaceeditor

 import hoursremaining

+import totalhours

+import plannedhours

 import workloadchart

Only in estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/build/lib/estimationtools: plannedhours.py
Only in estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/build/lib/estimationtools: totalhours.py
diff -ru estimationtoolsplugin-13312/estimationtoolsplugin/trunk/build/lib/estimationtools/utils.py estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/build/lib/estimationtools/utils.py
--- estimationtoolsplugin-13312/estimationtoolsplugin/trunk/build/lib/estimationtools/utils.py	2012-09-27 02:54:22.000000000 +0300
+++ estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/build/lib/estimationtools/utils.py	2014-04-15 10:18:57.000000000 +0300
@@ -24,6 +24,15 @@
     return Option('estimation-tools', 'estimation_field', 'estimatedhours',

         doc="""Defines what custom field should be used to calculate estimation charts.

         Defaults to 'estimatedhours'""")

+def get_planned_field():

+    return Option('estimation-tools', 'planned_field', 'planned',

+        doc="""Defines what custom field should be used to calculate estimation charts.

+        Defaults to 'estimatedhours'""")

+		

+def get_totalhours_field():

+    return Option('estimation-tools', 'totalhours_field', 'totalhours',

+        doc="""Defines what custom field should be used to calculate estimation charts.

+        Defaults to 'estimatedhours'""")

 

 def get_closed_states():

     return ListOption('estimation-tools', 'closed_states', 'closed',

@@ -48,6 +57,8 @@
     estimation field is not properly configured. """

     abstract = True

     estimation_field = get_estimation_field()

+    planned_field = get_planned_field()

+    totalhours_field = get_totalhours_field()

     def __init__(self, *args, **kwargs):

         if not self.env.config.has_option('ticket-custom', self.estimation_field):

             # No estimation field configured. Disable plugin and log error.

Only in estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/dist: EstimationTools-0.4.62-py2.7.egg
Binary files estimationtoolsplugin-13312/estimationtoolsplugin/trunk/dist/EstimationTools-0.4.6-py2.7.egg and estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/dist/EstimationTools-0.4.6-py2.7.egg differ
Only in estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/estimationtools: hoursplanned.py
diff -ru estimationtoolsplugin-13312/estimationtoolsplugin/trunk/estimationtools/__init__.py estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/estimationtools/__init__.py
--- estimationtoolsplugin-13312/estimationtoolsplugin/trunk/estimationtools/__init__.py	2008-09-24 19:30:20.000000000 +0300
+++ estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/estimationtools/__init__.py	2014-04-15 10:12:11.000000000 +0300
@@ -1,4 +1,6 @@
 import burndownchart

 import hoursinplaceeditor

 import hoursremaining

+import totalhours

+import plannedhours

 import workloadchart

Only in estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/estimationtools: __init__.py~
Only in estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/estimationtools: plannedhours.py
Only in estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/estimationtools: totalhours.py
diff -ru estimationtoolsplugin-13312/estimationtoolsplugin/trunk/estimationtools/utils.py estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/estimationtools/utils.py
--- estimationtoolsplugin-13312/estimationtoolsplugin/trunk/estimationtools/utils.py	2012-09-27 02:54:22.000000000 +0300
+++ estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/estimationtools/utils.py	2014-04-15 10:18:57.000000000 +0300
@@ -24,6 +24,15 @@
     return Option('estimation-tools', 'estimation_field', 'estimatedhours',

         doc="""Defines what custom field should be used to calculate estimation charts.

         Defaults to 'estimatedhours'""")

+def get_planned_field():

+    return Option('estimation-tools', 'planned_field', 'planned',

+        doc="""Defines what custom field should be used to calculate estimation charts.

+        Defaults to 'estimatedhours'""")

+		

+def get_totalhours_field():

+    return Option('estimation-tools', 'totalhours_field', 'totalhours',

+        doc="""Defines what custom field should be used to calculate estimation charts.

+        Defaults to 'estimatedhours'""")

 

 def get_closed_states():

     return ListOption('estimation-tools', 'closed_states', 'closed',

@@ -48,6 +57,8 @@
     estimation field is not properly configured. """

     abstract = True

     estimation_field = get_estimation_field()

+    planned_field = get_planned_field()

+    totalhours_field = get_totalhours_field()

     def __init__(self, *args, **kwargs):

         if not self.env.config.has_option('ticket-custom', self.estimation_field):

             # No estimation field configured. Disable plugin and log error.

diff -ru estimationtoolsplugin-13312/estimationtoolsplugin/trunk/EstimationTools.egg-info/PKG-INFO estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/EstimationTools.egg-info/PKG-INFO
--- estimationtoolsplugin-13312/estimationtoolsplugin/trunk/EstimationTools.egg-info/PKG-INFO	2013-07-02 12:06:36.000000000 +0300
+++ estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/EstimationTools.egg-info/PKG-INFO	2014-04-15 15:39:37.000000000 +0300
@@ -1,6 +1,6 @@
 Metadata-Version: 1.0

 Name: EstimationTools

-Version: 0.4.6

+Version: 0.4.62

 Summary: Trac plugin for visualizing and quick editing of effort estimations

 Home-page: UNKNOWN

 Author: Joachim Hoessler

diff -ru estimationtoolsplugin-13312/estimationtoolsplugin/trunk/EstimationTools.egg-info/SOURCES.txt estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/EstimationTools.egg-info/SOURCES.txt
--- estimationtoolsplugin-13312/estimationtoolsplugin/trunk/EstimationTools.egg-info/SOURCES.txt	2013-07-02 12:06:36.000000000 +0300
+++ estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/EstimationTools.egg-info/SOURCES.txt	2014-04-15 15:39:37.000000000 +0300
@@ -8,6 +8,9 @@
 estimationtools/__init__.py
 estimationtools/burndownchart.py
 estimationtools/hoursinplaceeditor.py
+estimationtools/hoursplanned.py
 estimationtools/hoursremaining.py
+estimationtools/plannedhours.py
+estimationtools/totalhours.py
 estimationtools/utils.py
 estimationtools/workloadchart.py
\ No newline at end of file
diff -ru estimationtoolsplugin-13312/estimationtoolsplugin/trunk/setup.cfg estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/setup.cfg
--- estimationtoolsplugin-13312/estimationtoolsplugin/trunk/setup.cfg	2011-12-01 09:01:50.000000000 +0200
+++ estimationtoolsplugin-13312_own/estimationtoolsplugin/trunk/setup.cfg	2014-04-14 10:45:46.000000000 +0300
@@ -1,3 +1,3 @@
 [egg_info]
-tag_build =
+tag_build = 2
 tag_svn_revision = true